% Copyright 2004 by Till Tantau <tantau@users.sourceforge.net>.
%
% In principle, this file can be redistributed and/or modified under
% the terms of the GNU Public License, version 2.
%
% However, this file is supposed to be a template to be modified
% for your own needs. For this reason, if you use this file as a
% template and not specifically distribute it as part of a another
% package/program, I grant the extra permission to freely copy and
% modify this file as you see fit and even to delete this copyright
% notice. 

\documentclass{beamer}
\usepackage{graphicx,multirow,booktabs,caption, array, listings}
\usepackage{times}  
\usepackage{url}
\usepackage{listings}
\usepackage{textcomp}
\usepackage{gensymb}
\usepackage{float}
\usepackage{adjustbox}
\usepackage{caption} 
\usepackage{subcaption}
\usepackage{array}
\usepackage{listings}
\usepackage{algorithm}
\usepackage[noend]{algpseudocode}
\usepackage{amsmath}
\usepackage{color, colortbl}
\usepackage{cite}
\usepackage{siunitx}
\usepackage{tikz}

\usetikzlibrary{arrows,shapes,positioning,shadows,trees, snakes}

\tikzset{
	basic/.style  = {draw, text width=3cm, drop shadow, font=\sffamily, rectangle},
	root/.style   = {basic, rounded corners=2pt, thin, align=center,
		fill=green!30},
	level 2/.style = {basic, rounded corners=6pt, thin,align=center, fill=green!60,
		text width=8em},
	level 3/.style = {basic, thin, align=left, fill=pink!60, text width=6.5em}
}

\usepackage{array}


% There are many different themes available for Beamer. A comprehensive
% list with examples is given here:
% http://deic.uab.es/~iblanes/beamer_gallery/index_by_theme.html
% You can uncomment the themes below if you would like to use a different
% one:
%\usetheme{AnnArbor}
%\usetheme{Antibes}
%\usetheme{Bergen}
%\usetheme{Berkeley}
%\usetheme{Berlin}
%Good
%\usetheme{Boadilla}
%\usetheme{boxes}
%\usetheme{CambridgeUS}
%\usetheme{Copenhagen}
%\usetheme{Darmstadt}
%\usetheme{default}
%\usetheme{Frankfurt}
%\usetheme{Goettingen}
%\usetheme{Hannover}
%\usetheme{Ilmenau}
%\usetheme{JuanLesPins}
%\usetheme{Luebeck}
%Good
%\usetheme{Madrid}
%\usetheme{Malmoe}
%\usetheme{Marburg}
%\usetheme{Montpellier}
%\usetheme{PaloAlto}
%\usetheme{Pittsburgh}
%Good
%\usetheme{Rochester}
%Good
\usetheme{Singapore}
%\usetheme{Szeged}
%\usetheme{Warsaw}

\setbeamertemplate{footline}[frame number]{}
\setbeamertemplate{navigation symbols}{}


\title{An IPv6 Routing Table Lookup Algorithm in Software and ASIC by Designing a High-Level Synthesis System}


\author{MD Iftakharul Islam}
% - Give the names in the same order as the appear in the paper.
% - Use the \inst{?} command only if the authors have different
%   affiliation.

\institute[Kent State University] % (optional, but mostly needed)
{
	Department of Computer Science\\
	Kent State University\\
	Kent, OH, USA.
}

\date[\today]{}
%\date{IEEE HPSR, 2021}

% - Use the \inst command only if there are several affiliations.
% - Keep it simple, no one is interested in your street address.

% This is only inserted into the PDF information catalog. Can be left
% out. 

% If you have a file called "university-logo-filename.xxx", where xxx
% is a graphic format that can be processed by latex or pdflatex,
% resp., then you can add a logo as follows:

% \pgfdeclareimage[height=0.5cm]{university-logo}{university-logo-filename}
% \logo{\pgfuseimage{university-logo}}

% Delete this, if you do not want the table of contents to pop up at
% the beginning of each subsection:


% Let's get started
\begin{document}
	
	\begin{frame}
		\titlepage
	\end{frame}
	
	\begin{frame}{Outline}
		\tableofcontents
		% You might wish to add the option [pausesections]
	\end{frame}
	
\section{Routing table lookup}

	\begin{frame}{Routing table lookup}
		\begin{itemize}
			\item Routing table lookup is a key operation of a router.
			\item Also known as "IP lookup"
			\item It involves performing the Longest prefix match (LPM) in order to find the next-hop.
			

\begin {table}[H]
  \caption {An example routing table} 
\resizebox{.7\columnwidth}{!}{%
	\begin{tabular}{ | m{5.9cm} | m{1.6cm} |} 
		\hline Prefix & Next-hop\\
		\hline 11aa:800:1100::/48 & $3$\\
		\hline 180a:410:8800:702::/64 & $4$\\
		\hline 200a:410:8000:702::/64 & $1$\\
		\hline \textcolor{red}{200a:410:8000::/40} & $2$\\
		\hline \textcolor{red}{200a:410:8086::/46} & $3$\\
		\hline 200a:410:8000:702::0df/128 & $2$\\						
		\hline 
	\end{tabular}% 	
}
\end {table}
		
		\item Lookup(200a:410:808d:500::300) $\implies 3$

			
		\end{itemize}
		
	\end{frame}

\begin{frame}{Challenges of IP lookup}
\begin{itemize}

	\item Extremely high throughput needed.
\begin{itemize}
	\item $4.8$ Tb/s Brodcom Jericho2 chip in many core routers can forward \textcolor{red}{$2$ billion packets per second}.
\end{itemize}

\item Forwarding table of a core router can be extremely large
\begin{itemize}
	\item Already exceeded \textcolor{red}{$100k$+} IPv6 entries and growing very rapidly.
\end{itemize}	

\item An IPv6 prefix can be $128$ bits while IPv4 prefix can be $32$ bits long. Thus, IPv6 lookup may need \textcolor{red}{$4 \times$} processing and memory compared to IPv4 lookup.
	
\end{itemize}
\end{frame}

\begin{frame}{Design Goals}
	\begin{itemize}
		
		\item In software
		\begin{itemize}
			\item high throughput
			\item Low memory consumption
		\end{itemize}				
		
		\item In ASIC
		\begin{itemize}
			\item Low power and area (they are standard metrics for ASICs)
		\end{itemize}		
		\item In pipelined ASIC, throughput is constant at line rate.
		
		
		
	\end{itemize}
\end{frame}
	
\section{Existing solutions}

\begin{frame}{IP lookup implementation}
%based on https://texample.net/tikz/examples/feature/trees/
	
\begin{adjustbox}{max totalsize={\textwidth}{\textheight},center}
		
\begin{tikzpicture}[
level 1/.style={sibling distance=40mm},
edge from parent/.style={->,draw},
>=latex]

% root of the the initial tree, level 1
\node[root] {IP lookup implementation}
% The first level, as children of the initial tree
child {node[level 2] (c1) {Software}}
child {node[level 2] (c2) {Pipelined ASIC}}
child {node[level 2] (c3) {TCAM}}
child {node[level 2] (c4) {FPGA}}
child {node[level 2] (c4) {GPU}};

% The second level, relatively positioned nodes
\begin{scope}[every node/.style={level 3}]
\node [below of = c1, xshift=15pt] (c11) {Trie};
\node [below of = c11] (c12) {Hash};

\node [below of = c2, xshift=15pt] (c21) {Trie};
\node [below of = c21] (c22) {Hash};

\end{scope}

% lines from each level 1 node to every one of its "children"
\foreach \value in {1,2}
\draw[->] (c1.195) |- (c1\value.west);

\foreach \value in {1,...,2}
\draw[->] (c2.195) |- (c2\value.west);

\end{tikzpicture}

\end{adjustbox}
	
	\begin{itemize}
		\item High-speed routers generally use pipelined ASIC to implement IP lookup. 
		\item This dissertation focuses on Software and ASIC based IP lookup.
		\item Software and ASIC use algorithmic solutions.
		\item  Software and ASIC based IP lookup solutions can be categorized as Trie and Hash based solutions.
		\item \textcolor{red}{A Trie based solution} is the main focus of this dissertation.
	\end{itemize}

\end{frame}

\begin{frame}{Trie based IP lookup algorithms}

\begin{figure}[] 
	\begin{tikzpicture}[]
	% draw horizontal line   
	\draw (0,0) -- (9,0);
	
	
	% draw vertical lines
	\foreach \x in {0,3,6,9}
	\draw (\x cm,40pt) -- (\x cm,-5pt);
	
	\foreach \x in {1.5,4.5,7.5}
	\draw (\x cm,10pt) -- (\x cm,-5pt);
	
	% draw nodes
	\draw (0,0) node[below=3pt] {$1997$} node[above=40pt] {\begin{tabular}{c} \textcolor{blue}{Lule\aa $\ $} \\ {[SIGCOMM]}\end{tabular}};
	\draw (1.5,0) node[below=3pt] {$1999$} node[above=10pt] {\begin{tabular}{c} \textcolor{blue}{LC-Trie} \\ {[JSAC]}\end{tabular}};
	\draw (3,0) node[below=3pt] {$2004$} node[above=40pt] {\begin{tabular}{c} \textcolor{blue}{Tree Bitmap} \\ {[SIGCOMM CCR]}\end{tabular}};
	\draw (4.5,0) node[below=3pt] {$2009$} node[above=10pt] {\begin{tabular}{c} \textcolor{blue}{SST} \\ {[ICNP]}\end{tabular}};
	\draw (6,0) node[below=3pt] {$2010$} node[above=40pt] {\begin{tabular}{c} \textcolor{blue}{Flashtrie} \\ {[INFOCOM]}\end{tabular}};
	\draw (7.5,0) node[below=3pt] {$2014$} node[above=10pt] {\begin{tabular}{c} \textcolor{blue}{SAIL} \\ {[SIGCOMM]}\end{tabular}};
	\draw (9,0) node[below=3pt] {$2015$} node[above=40pt] {\begin{tabular}{c} \textcolor{blue}{Poptrie} \\ {[SIGCOMM]}\end{tabular}};
	\end{tikzpicture}
	
\end{figure}
\begin{itemize}
	\item \textbf{Poptrie} is the state of the art IP lookup because it requires very small memory and can perform very fast lookup. 
	
	\item Poptrie however uses $6$-bit stride.
	\item \textbf{CP-Trie} is extension of \textbf{Poptrie} which can uses $8-16$ bit stride, thus results more efficient lookup.
\end{itemize}

\end{frame}

\begin{frame}{Poptrie based IP lookup}
	
	\begin{figure}[!t]
		\centering
		\includegraphics[width=8.4cm]{tree-poptrie}
	\end{figure}
	
\end{frame}

\begin{frame}{Limitation of Poptrie}
	
	\begin{itemize}
		\item Poptrie uses $6$-bit stride. This is because PopCount CPU instruction can only process $64$ bits ($2^6=64$). 	
		\item As a result, Poptrie splits an IPv6 routing table table into  \textcolor{red}{$20$ levels}: level $16$, $22$, $28$, $34$, $40$, $46$, $52$, $58$, $64$, $70$, $76$, $82$, $88$, $94$, $100$, $106$, $112$, $118$, $124$ and $130$.
		\item In CP-Trie, we store \textcolor{red}{cumulative PopCount} along with bitmap with allows it to use \textcolor{red}{longer stride ($8-16$ bit)}.
		\item CP-Trie splits an IPv6 routing table into \textcolor{red}{$15$ levels}: level $16$, $24$, $32$, $40$, $48$, $56$, $64$, $72$, $80$, $88$, $96$, $104$, $112$, $120$ and $128$.
		
	\end{itemize}
	
\end{frame}


\begin{frame}{Benefits of fewer levels}
	
	\begin{itemize}
		
		\item Fewer number of levels result in
		\begin{itemize}
			\item \textcolor{red}{faster lookup, higher throughput in software}
			\item \textcolor{red}{fewer logic and SRAMs $\implies$ lower power/area in ASIC} 
		\end{itemize}
		

		\begin{itemize}
			
		\item \textcolor{red}{Fewer memory accesses} which is very \textcolor{red}{critical in pipelined ASIC}. In pipelined ASIC, \textcolor{red}{\# of memory accesses = \# of SRAM blocks
	needed} (each pipeline stage has to access SRAM in parallel. So, each memory access has to be in a separate SRAM block so that memory accesses don't stall the pipeline).			

			\begin{figure}[!t]
				\centering
				\includegraphics[width=3cm]{pipelined-asic}			
			\end{figure}
		
		\begin{itemize}
			\item It also has been found that \textcolor{red}{fewer large SRAM blocks are more area efficient than many smaller SRAM blocks}. This is because $85\%$ area of a SRAM is used for control logic.

			\item This is why, \textcolor{red}{fewer levels reduces the number of SRAM blocks needed in ASIC which results in smaller area/power.}			
		\end{itemize}
			
		\end{itemize} 
		
	\end{itemize}
	
\end{frame}




\section{CP-Trie based IP lookup}

\begin{frame}{CP-Trie based IP lookup}

\begin{figure}[!t]
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=5.6cm]{treewopush}
	\end{subfigure}%
	~ 	
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=5.6cm]{tree}
	\end{subfigure}%
	
	\begin{subfigure}[t]{.42\textwidth}
		\centering
		\includegraphics[width=5.9cm]{array}
		
	\end{subfigure}%	
	~
	\begin{subfigure}[t]{.58\textwidth}
		\centering
		\includegraphics[width=3.8cm]{lookup}
		\caption{Lookup in CP-Trie}
	\end{subfigure}%	
	
\end{figure}

\end{frame}



\section{Implementations}

	\begin{frame}{Implementations}
		\begin{itemize}			
			\item Implemented both Poptrie and CP-Trie in C. Source code is publicly available at \url{https://tamimcse.github.io/cp-trie/}.
			
			
			\item We used C2RTL HLS tool to generate the Verilog RTL code from C code.
			
			\item We tested the generated Verilog code by iVerilog simulator.
			 
			 \item We performed the physical synthesis of the Verilog code using OpenROAD. OpenROAD generates the physical chip layout and power, area and timing characteristics of ASIC.
			 
\begin{figure}[!t]
	\centering
	\includegraphics[width=4.9cm]{hls-flow}
\end{figure}

		\end{itemize}
	
		
	\end{frame}

\section{Evaluation in ASIC and Software}
\begin{frame}{Evaluation in ASIC}
\begin {table}[H]
\centering
\resizebox{.8\columnwidth}{!}{%
	\begin{tabular}{ | m{5cm}| m{3cm}| m{3cm} | m{3cm} |}
	\hline  & Poptrie & CP-Trie & Improvement (\%) \\
	\hline Clock speed & $1$ GHz & $1$ GHz & Same\\
	\hline Internal Power & $76.5$ mW & $64.6$ mW & 15\%\\
	\hline Switching Power & $24.4$ mW & $22.2$ mW & 9\%\\
	\hline Leakage Power & $1.15$ mW& $0.926$ mW & 14\%\\
	\hline Total Power & $102.05$ mW & $87.726$ mW & 14\%\\
	\hline Area & $0.0658$ $mm^2$ & $0.0523$ $mm^2$ & 20.5\%\\
	\hline 
	\end{tabular}%
}
\end {table}
    \begin{itemize}
    	\item OpenROAD timing report shows that our implementation can achieve $1$ GHz clock speed without timing violation. Thus, it can perform $1$ billion lookups per second ($1$ lookup in every $1$ ns).
    	\item SRAM implemation is missing in Open Cell Library. We use registers instead.
    	\item Poptrie needs $79$ SRAM blocks and CP-Trie needs $59$ SRAM blocks. So, we expect CP-Trie to be even more efficient in area and power compared to Poptrie when SRAM is incorporated.
	\end{itemize}

\end{frame}
	

\begin{frame}{Evaluation in Software}
	\begin {table}[H]
	\caption {FIB dataset} \label{fibdataset} 
\resizebox{.7\columnwidth}{!}{%
		\begin{tabular}{ | m{.8cm}| m{2.3cm} | m{3.8cm}  |}
			\hline Name & \# of prefixes &Longest prefix length\\
			\hline fib0 & $105,363$ & $48$ \\
			\hline fib1 & $102,126$ & $48$\\
			\hline fib2 & $79,431$ & $64$\\
			\hline fib3 & $103,067$ & $128$\\
			\hline fib4 & $105,957$ & $128$\\
			\hline fib5 & $102,739$ & $64$\\
			\hline fib6 & $104,235$ & $48$\\
			\hline fib7 & $100,899$ & $64$\\
			\hline fib8 & $102,731$ & $128$\\
			\hline 
		\end{tabular}%
}
	\end {table}
		\begin{itemize}									
		\item We obtained real routing tables of core routers from RouteView project. The snapshot was taken on January $17$, $2021$ at 3 PM EST.				
		\end{itemize}
			
		\end{frame}

	
	\begin{frame}{Memory consumption}
	\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{memory}
	\caption{Memory consumption for different FIBs}\label{memorycomp}
	\end{figure}
	\end{frame}
	
\begin{frame}{Lookup traffics}
\begin{itemize}									
	\item \textbf{Prefix traffic} consists of the prefixes in our FIBs. Prefix traffic ensures that the lookups are spread across a FIB.			
	\item \textbf{Repeated traffic} consists of $2^{24}$ randomly selected prefixes from the FIBs (with possible duplicates) and adding random bits at the "don't care" fields of the prefixes. Each IP in repeated traffic is looked up $10$ times repeatedly. Repeated traffic is \textbf{analogous to real Internet trace}.
	
	\item \textbf{Sequential traffic } consists of $2^{8}$ sequentially increasing IPv6 addresses. The start address of the sequential traffic is selected such that all the IPs in sequential traffic requires matching up to the last level of the FIB. We use sequential traffic to measure the worst lookup throughput for a FIB.
	
	\item \textbf{Random traffic } consists of $2^{24}$ random IPv6 addresses within 2000::/4.
\end{itemize}
\end{frame}
	
	\begin{frame}{Lookup performance}
\begin{figure}[!t]
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=5.8cm]{lookup-throughput-prefix}
		\caption{Prefix traffic}\label{lookup-throughput-prefix}
	\end{subfigure}%
	~ 	
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=5.8cm]{lookup-throughput-repeated}
		\caption{Repeated traffic (analogous to real Internet trace)}\label{lookup-throughput-repeated}
	\end{subfigure}%
	
	\begin{subfigure}[t]{.5\textwidth}
		\centering
		\includegraphics[width=5.8cm]{lookup-throughput-sequential}
		\caption{Sequential traffic}
	\end{subfigure}%
	~
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=5.8cm]{lookup-throughput-random}
		\caption{Random traffic (not a realistic traffic)}
	\end{subfigure}%
\end{figure}
	\end{frame}	
	
	\begin{frame}{Update performance}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{update}
		\caption{Average insertion time per prefix (smaller is better)}\label{update}
	\end{figure}
	\end{frame}

\section{C2RTL HLS tool}

\begin{frame}{CP-Trie ASIC implementation}
	
	\begin{itemize}
		
		\item Currently, a new algorithm in ASIC is generally implemented in hand-coded Verilog RTL. 
		
		\item Writing Verilog RTL manually is extremely complex, tedious and error-prone because we need to use circuit level abstraction.
		
		\item This is why, very few research was done on IP lookup in ASIC (except by router makers such as Cisco, Juniper, Broadcom, Nokia, etc)
		
		\item High-level synthesis can be a solution to this problem. HLS is a design methodology where ASIC is designed using high-level languages such as C or SystemC. 
		
		\item HLS generates corresponding Verilog or VHDL RTL from C or SystemC code.
		
	\end{itemize}
	
\end{frame}

\begin{frame}{Why a new HLS system?}
	
	\begin{itemize}
	
		\item The theory of HLS is well established, but HLS has not been adopted in routing/switching chips, to the best of our knowledge.
		
		\item Existing open source HLS tools such as Bambu and LegUp don't do pipelining (needed to achieve line rate). They also target FPGA, not ASIC. 
		
		\item Alladin (an open source ASIC simulator) does  pipelining, but it doesn't generate RTL code. It also doesn't support control-flow, thus cannot be used for IP lookup (it was designed for data-flow intensive applications). 
		
		\item To fill the gap, we developed a new HLS tool named \textbf{C2RTL} that generates Verilog RTL for pipelined ASIC.
		
	\end{itemize}
	
\end{frame}

\begin{frame}{C2RTL HLS tool}
	
	\begin{itemize}
		
		\item We designed C2RTL for trie based IP Lookup and Packet Classification
		
		\item C2RTL takes C code as input and generates corresponding synthesizable Verilog RTL code. 
		
		\item C2RTL is implemented as a GCC plugin.
		
		\item We made the source code publicly available \url{https://tamimcse.github.io/c2rtl}.
		
	\end{itemize}
	
\end{frame}


\begin{frame}{Programming convention in C2RTL}
	
	\begin{itemize}
		\item An input program in C2RTL is implemented in C language,
		but with several restrictions.
	\end{itemize}
	
	\begin {table}[H]
	\caption {programming restrictions in C2RTL} \label{program_restrictions} 
	\begin{center}
		\resizebox{.6\columnwidth}{!}{%
			\begin{tabular}{ | m{9cm}|}
				\hline No loop (while, for, do-while)\\
				\hline No unstructured control flow (goto, break, continue) \\
				\hline No ternary operation \\
				\hline No dynamic memory allocation\\
				\hline No global variables\\
				\hline No structure\\
				\hline No switch\\
				\hline No function call\\
				\hline Each branch has to have a separate return statement\\
				\hline 
			\end{tabular}
		} 	
	\end{center}
	\end {table}
	
\end{frame}


\begin{frame}{C2RTL design flow}
	\begin{itemize}
	\item We implement the formal method of high-level synthesis.
\end{itemize}	
	\begin{figure}[!t]
		\centering
		\includegraphics[width=7cm]{c2rtl-flow}
	\end{figure}
	
\end{frame}



\begin{frame}{Validating C2RTL} 
	
	\begin{itemize}
		\item We evaluated C2RTL by implementing SAIL, Poptrie and CP-Trie based IPv6 lookup and TabTree based packet classification. 
		\item We then evaluated the generated Verilog code using iVerilog simulator to check if they are functionally correct. Other HLS tools also use similar approach. We also open sourced it so that others can report if there is any issue.

        \item We then evaluated the generated Verilog with OpenROAD. Our OpenROAD reports show that our generated Verilog is synthesizable and doesn't violate timing constraints which indicate that the scheduling/pipelining worked properly.
        
		
	\end{itemize}
	
\end{frame}


\begin{frame}{Evaluation using C2RTL}
	\centering
	\resizebox{\columnwidth}{!}{%
		\begin{tabular}{ | m{2.9cm}| m{2.1cm}| m{2.3cm}| m{2.1cm} | m{2.6cm} |}
			\hline  & Poptrie & SAIL & CP-Trie & TabTree\\
			\hline Clock speed & $1$ GHz & $1$ GHz & $1$ GHz & $1$ GHz \\
			\hline Internal Power & $76.5$ mW & $0.722$ mW & $64.6$ mW & $0.033$ mW\\
			\hline Switching Power & $24.4$ mW & $0.229$ mW & $22.2$ mW & $0.0054$ mW\\
			\hline Leakage Power & $1.15$ mW & $0.0108$ mW & $0.926$ mW & $0.00061$ mW\\
			\hline Total Power & $102.05$ mW & $0.961$ mW & $87.726$ mW & $0.0391$ mW\\
			\hline Area & $0.0658$ $mm^2$ & $0.00061$ $mm^2$ & $0.0523$ $mm^2$ & $0.000034$ $mm^2$\\
			\hline 
		\end{tabular}
	}
\end{frame}


	
\begin{frame}{}
	\centering \Large
	\Huge{Thank You}
	
	
	\large{Scroll down for backup slides}
\end{frame}


\begin{frame}{Routing table represented as a Trie}
	\begin{figure}[!t]
		\begin{subfigure}[t]{\textwidth}
			\centering
			\includegraphics[width=5.2cm]{trie-ip}
			\caption{A routing table with prefixes and the corresponding trie}\label{trie-ip}
		\end{subfigure}%
		
		\begin{subfigure}[t]{.5\textwidth}
			\centering
			\includegraphics[width=5.5cm]{trie-ip-stride2}
			\caption{Corresponding trie with $2$-bit stride}\label{trie-ip-stride2}
		\end{subfigure}%
		~
		\begin{subfigure}[t]{.5\textwidth}
			\centering
			\includegraphics[width=5.5cm]{trie-ip-stride2-leaf-pushing}
			\caption{Corresponding trie with $2$-bit stride with leaf pushing}\label{trie-ip-stride2-leaf-pushing}
		\end{subfigure}%
	\end{figure}
\end{frame}


\begin{frame}{Drawbacks of CP-Trie}
	\begin{itemize}
		\item CP-Trie however requires slightly more memory because it needs to store additional cumulative population count.
		
		\item CP-Trie also require slightly more update time because it may need to modify the cumulative PopCounts of more than one node. 
	\end{itemize}
\end{frame}

\begin{frame}{Why did you select level 16, 24, 32, 40,.?}
	\begin{itemize}	
		\item When we add a new prefix, if we use 8 bit stride, we may need to allocate 4 groups ($\frac{2^8}{64}$). Increasing the number of stride increases the \# of groups significantly. For instance, if we use 12 bit stride, we will need $2^6$ groups ($\frac{2^{12}}{64}$). So, there is a trade-off between the \# of groups and stride size. 8 bit stride is a good balance because it has only 4 groups. 
		
		\item Note that each group consumes 64 + 16 bits and we may need 4 groups for each new prefix. So, to reduce memory and increase lookup speed, we use 8 bit sride. 
		
		\item Now, for the first level, we know that there is only one root. So, we use 16 bit stride $2^{10}$ groups ($\frac{2^{16}}{2^6}$). 
		
		\item Now, it is possible that your prefixes follow some distribution. And if there is fewer prefixes in some area (for instance, prefixes with length 64-128), you may assign larger stride. However, this is out of the scope of this work. We hope someone will work on it in the future.
	\end{itemize}
\end{frame}

\begin{frame}{What will be the latency of the lookup?}
	\begin{itemize}	
		\item In CPU, average latency = $\frac{1}{lookup\_throughput}$ = around $30$ ns ($\frac{10^9}{33 * 10^6}$). We didn't calculate the variance. Here, we are mostly interested in the throughput (like other previous works)
		
		\item In ASIC, the latency is same as the \# of pipeline stages (during scheduling). If we need $32$ pipeline stages and clock speed is $1$ GHz ($1$ ns latency), then total latency is $32$ ns.
		
		\item Note that, we are mostly interested in throughput rather than latency. In typical routing/switching chip, we make the design decision. In routing/switching chip, everything is pipelined. This allows us to achieve line rate sacrificing latency.
	\end{itemize}
\end{frame}

\begin{frame}{What  not implement a $256$ bit PopCount in ASIC?}
	\begin{itemize}	
		\item It is possible to implement $256$-bit PopCount or $65536$-bit PopCount in ASIC (for $8$ ort $16$ bit stride respectively), their area and power consumption would be substantially higher than that of a $64$-bit PopCount. Although this can be a practical solution in the future, we investigated an alternative approach where we don't need 256-bit PopCount.
	\end{itemize}
\end{frame}

\begin{frame}{What  random traffic is not a realistic traffic?}
	\begin{itemize}	
		\item The traffics are not within the range of the prefixes. So, we don't find matches for those prefixes. In such case, routing protocol will populate the routes (a router also may have a default route).
		
		\item As Poptrie uses direct indexing, it directly finds the un-match in the first level. We can also use the approach in CP-Trie if needed.
	\end{itemize}
\end{frame}

\begin{frame}{Chip layout}
\begin{figure}[!t]
	\begin{subfigure}[t]{6cm}
		\centering
		\includegraphics[width=5cm]{poptrie-gds}
		\caption{Poptrie}\label{poptrie-gds}
	\end{subfigure}%
	~
	\begin{subfigure}[t]{6cm}
		\centering
		\includegraphics[width=5cm]{cptrie-gds}
		\caption{CP-Trie}\label{cptrie-gds}
	\end{subfigure}%	
	
	\caption{Chip layout (GDSII) of the Poptrie and CP-Trie }\label{gds}
\end{figure}	
\end{frame}

\begin{frame}{Existing HLS tools}
	\begin{itemize}
		\item Current HLS tools focus on C or SystemC based system design.
		\begin{itemize}
			\item Mentor's Catapult
			\item Cadence's Stratus
			\item NEC's CyberWorkBench
			\item Synopsys' Synphony
			\item SWSL \textbf{[ANCS 2013]} (designed for IP lookup)
		\end{itemize}
		\item Switch compiler for programmable ASIC.
		\begin{itemize}
			\item LEAP \textbf{[ANCS 2012]}, Domino \textbf{[SIGCOMM 2016]}
		\end{itemize}
		\item HLS tools for FPGA.
		\begin{itemize}
			\item Xilinx's Vivado
			\item Bambu \textbf{[FPL 2013]}
			\item LegUp \textbf{[FPGA 2011]}
		\end{itemize}
	\end{itemize}
	
\end{frame}

\begin{frame}{Intermediate code generation by GCC}
	
	\begin{figure}[!t]
		\begin{subfigure}[t]{0.5\textwidth}
			\centering
			\includegraphics[width=5.8cm]{sail_c}
			\caption{Example IPv4 Lookup in C}\label{sail_c}
		\end{subfigure}%
		~ 	
		\begin{subfigure}[t]{0.5\textwidth}
			\centering
			\includegraphics[width=5.8cm]{cfg}
			\caption{Intermediate code in SSA and CFG form}\label{cfg}
		\end{subfigure}%
	\end{figure}
	
\end{frame}

\begin{frame}{Control and Data flow graph (CDFG)}
	
	\begin{figure}[!t]
		\centering
		\includegraphics[width=10cm]{cdfg}
	\end{figure}
	
\end{frame}

\begin{frame}{Scheduling/pipelining}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=3.1cm]{pipeline4}
	\end{figure}		
\end{frame}


\begin{frame}{Register Insertion}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{register-insertion}
		\caption{Block diagram of a pipelined ASIC}\label{register-insertion}
	\end{figure}		
\end{frame}


\begin{frame}{Scheduling and Register Insertion in C2RTL} 
	
	\begin{figure}[!t]
		\centering
		\includegraphics[width=2.5cm]{scheduling}
	\end{figure}
	
	\begin{itemize}
		\item Pipeling is performed by scheduling and register insertion.
		\item We used As Late as Possible (ALAP) scheduling algorithm.
		\item We obtained the latency of the operations from Bambu's $45$ nm Nandgate Open Cell library characterization. 
		\item We insert register when the result of an operation crosses cycle boundary.
	\end{itemize}
	
\end{frame}


\begin{frame}{RTL Generation} 
	
	\begin{itemize}
		\item We implement each operation using a Verilog module from a component library obtained from Bambu.
		\item We implement each arrays using register files.
		
	\end{itemize}
	
\end{frame}

\begin{frame}{MUX tree generation}
	
	\begin {table}[H]
	\centering
	\caption {An example predicates for a SSA $\phi$ operation} \label{mux} 
	\resizebox{.3\columnwidth}{!}{%
		\begin{tabular}{ | m{1cm}| m{.3cm}| m{.3cm}| m{.3cm}| m{.3cm}|}
			\hline  & \multicolumn{4}{|l|}{Selectors} \\
			\hline Inputs & $S_1$ & $S_2$ & $S_3$ & $S_4$ \\
			\hline $I_1$ & $*$ & $*$ & $*$ & $0$ \\
			\hline $I_2$ & $*$ & $1$ & $1$ & $1$ \\
			\hline $I_3$ & $*$ & $0$ & $1$ & $1$ \\
			\hline $I_4$ & $0$ & $*$ & $0$ & $1$ \\
			\hline $I_5$ & $1$ & $*$ & $0$ & $1$ \\
			\hline 
		\end{tabular} 	
	}
	\end {table}
	
	\begin{figure}[!t]
		\begin{subfigure}[t]{0.4\textwidth}
			\centering
			\includegraphics[width=3cm]{predicate-splitting-tree}
			\caption{Predicates splitting tree}\label{sail_c}
		\end{subfigure}%
		~ 	
		\begin{subfigure}[t]{0.42\textwidth}
			\centering
			\includegraphics[width=3cm]{mux-tree}
			\caption{Corresponding MUX tree}\label{cfg}
		\end{subfigure}%
	\end{figure}
	
\end{frame}


\begin{frame}{Equivalence checker for C2RTL?} 
	
	\begin{itemize}
		\item HLS tools use formal method (correct-by-construction approach) to generate RTL code. However, a bug in our implementation can produce incorrect Verilog (such problem also occurs in other commercial Verilog tools)
		
		\item To avoid this limitation, existing HLS tools generally use Verilog simulation against a test-bench. We also used a similar approach. We used iVerilog simulator to test our generated Verilog code for a test bench.
		
		\item Although it's possible to develop an equivalence checker between C code and Verilog RTL code, we don't do that (most of open source HLS tools also don't have equivalence checkers). Developing an equivalence checker itself is a broad research area and out of the scope of this dissertation (thus mentioned as limitations) 
		
	\end{itemize}
	
\end{frame}	

\begin{frame}{Non-pipelined ASIC}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=10cm]{non-pipelined-asic}
	\end{figure}
\end{frame}


\begin{frame}{Which Algorithm is used for scheduling/pipelining?} 
	
	\begin{itemize}
		\item We use ALAP algorithm. In order to preform ALAP, we first need to implement ASAP. 
		
		\item ASAP can be implemented using topological sorting and single source longest path problem.
		
		\item Once ASAP is executed, ALAP can be implemented by executing single source longest path from the last node.
		
	\end{itemize}
	
\end{frame}

\begin{frame}{Architecture of the Internet}
\begin{figure}[!t]
	\centering
	\includegraphics[width=12cm]{internet-architecture-new}
\end{figure}
\end{frame}

\begin{frame}{Router architecture}
\begin{figure}[!t]
	\centering
	\includegraphics[width=10cm]{router-architecture}
	\caption{Architecture of a Router}\label{router-architecture}
\end{figure}
\end{frame}


\begin{frame}{Router forwarding plane}
\begin{figure}[!t]
	\centering
	\includegraphics[width=8cm]{Tamim-ASIC}
	\caption{Forwarding plane of a router.}\label{asic-architecture}
\end{figure}
\end{frame}

\begin{frame}{Ingress packet processor}
\begin{figure}[!t]
	\centering
	\includegraphics[width=12cm]{ingress-packetprocessor}
	\caption{Modules of an ingress packet processor.}\label{ingress-packetprocessor}
\end{figure}
\end{frame}

\begin{frame}{Packet classification}
\begin {table}[H]
\caption {Example ruleset (for packet classification)} \label{classi} 
\begin{center}
	\begin{tabular}{ | m{1cm} | m{1.2cm} | m{1.2cm} | m{1.2cm}| m{1.2cm} | m{1.4cm}| m{1.4cm}|} 
		\hline Rule & SA & DA& SP & DP & Protocol & Action\\
		\hline r1 & $01100*$ & $01100*$ & $111$ & $111$ & 80 & forward\\
		\hline r2 & $11010*$ & $*$ & $10*$ & $11*$ & 22& drop\\
		\hline r3 & $*$ & $01111*$ & $000$ & $001$ & * & enqueue\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}
\end{frame}

\begin{frame}{Linux+Domino based router}
\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{Linux-Router.png}
	\caption{Programmable pipeline based Linux router}\label{Linux-Router}
\end{figure}
\end{frame}	
	
\begin{frame}{SAIL\_U and SAIL\_L in Domino}
\begin {table}[H]
\caption {Comparison between SAIL\_U and SAIL\_L in a Programmable Pipeline} \label{sailpipeline} 
\begin{center}
	\begin{tabular}{ | m{6cm} | m{2cm} | m{2cm} |}
		\hline  & SAIL\_U& SAIL\_L \\
		\hline Number of pipeline stages & $15$  & $32$ \\
		\hline Maximum \# of atoms/stage & $5$ & $6$ \\
		\hline Processing latency & $15$ ns& $32$ ns \\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}
\end{frame}	

\begin{frame}{Memory consumption in SAIL with PopCount}
\begin{figure}[!t]
	\centering
	\includegraphics[width=12cm]{memory-cumupopcount}
	\caption{Memory consumption for different FIBs}\label{memorycomp2}
\end{figure}
\end{frame}

\begin{frame}{Lookup cost for different levels in SAIL with PopCount}
\begin{figure}[!t]
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=6cm]{candlesticks-sailbm.png}
		\caption{SAIL\_U}\label{sailbm-lookup}
	\end{subfigure}%
	~ 
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=6cm]{candlesticks-saill.png}
		\caption{SAIL\_L}\label{saill-lookup}
	\end{subfigure}%
	\caption{Lookup cost for different levels.}\label{cpuvsplen}
\end{figure}
\end{frame}
	
\begin{frame}{Area-delay trade-off}
	\begin {table}[t]
	\caption {Area and delay trade-offs for an adder} \label{delay-area-tradeoff} 
	\begin{center}
		\begin{tabular}{ | m{1.8cm}| m{.5cm}| m{.5cm}| m{.5cm} | m{.5cm} | m{.5cm} | m{.6cm} |}
			\hline Delay (ps) & $220$ & $400$ & $580$ & $760$ & $940$ & $1220$\\
			\hline Area & $556$& $254$ & $225$ & $216$ & $210$ & $206$\\
			\hline 
		\end{tabular} 	
	\end{center}
	\end {table}
	
\end{frame}
	
\end{document}


